import { useState, useEffect } from 'react';
import { getLocalCache, setLocalCache } from '../util/local-cache';
import { newGuid } from 'primeobjects-helper-util/build/cjs/uuid';
import { SSR, _window } from 'primeobjects-helper-util/build/cjs/constants';
import { doNothing } from 'primeobjects-helper-util/build/cjs/core';
var SOURCE = 'PO-USE-EVENT';
export var useEvent = function (key, senderName) {
    var data = getLocalCache(key, {});
    var _a = useState(''), valueRefreshed = _a[0], setValuedRefreshed = _a[1];
    var isSSR = SSR;
    doNothing(valueRefreshed);
    var messageHandler = function (message) {
        var data = message.data;
        if (data.source == SOURCE) {
            setValuedRefreshed(newGuid());
        }
    };
    var sendEvent = function (key, value, expireMinutes) {
        if (SSR)
            return console.error('Require window object.');
        setLocalCache(key, { value: value, senderName: senderName, id: newGuid() }, expireMinutes);
        _window.postMessage({ source: SOURCE, key: key });
    };
    useEffect(function () {
        if (isSSR) {
            console.error('Require window object.');
        }
        else {
            if (_window.addEventListener) {
                _window.addEventListener("message", messageHandler);
            }
            else {
                _window.attachEvent("onmessage", messageHandler);
            }
        }
        return function () {
            if (_window.removeEventListener)
                _window.removeEventListener("message", messageHandler);
            if (_window.detachEvent)
                _window.detachEvent("onmessage", messageHandler);
        };
    }, [isSSR]);
    return [data === null || data === void 0 ? void 0 : data.value, sendEvent, data === null || data === void 0 ? void 0 : data.senderName];
};
